//+------------------------------------------------------------------+
//|                                           Regular Array test.mq4 |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

extern bool SetBefore = true;
extern int period = 10;

double RegArr[];
double MAonRA[];
static int last_Bars=0;

int init()
  {
   IndicatorBuffers(2);
   SetIndexBuffer(0,MAonRA);
   SetIndexStyle(0,DRAW_LINE);
   
   ArrayResize(RegArr,Bars);
   ArrayInitialize(RegArr,Open[1]);
   last_Bars = Bars;
   return(0);
  }
//+------------------------------------------------------------------+
void ResetArray(double& arr[], int size)
{
   if(SetBefore)ArraySetAsSeries(arr,false);
   ArrayResize(arr, size);
   ArraySetAsSeries(arr, true);
}
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   if( counted_bars<0 ) return(-1);
   if( counted_bars>0 ) counted_bars--;
   int i, limit;
   limit = Bars - counted_bars - 1; 
   
   // printing 4 last current values BEFORE resize
   for(i=3; i>=0; i--)
      Print("BEFORE-------- resize RegArr[",i,"] = ",DoubleToStr(RegArr[i],Digits+1));  
   // printing 4 first bars values BEFORE resize   
   for(i=Bars-1; i>=Bars-4; i--)
      Print("BEFORE--------resize RegArr[",i,"] = ",DoubleToStr(RegArr[i],Digits+1));  
   
   if( Bars > last_Bars )
   {
      ResetArray(RegArr,Bars);
      last_Bars = Bars;
   }
   // printing 4 last current values AFTER RESIZE & before filing
   for(i=3; i>=0; i--)
      Print("----------AFTER resize RegArr[",i,"] = ",DoubleToStr(RegArr[i],Digits+1));  
   // printing 4 first bars values AFTER RESIZE & before filing
   for(i=Bars-1; i>=Bars-4; i--)
      Print("----------AFTER resize RegArr[",i,"] = ",DoubleToStr(RegArr[i],Digits+1));  
   
   for(i=limit; i>=0 ; i--)
      RegArr[i] = ( Open[i] + Close[i] + Open[i+1] + Close[i+1] )/4;

   for(i=limit; i>=0 ; i--)
      MAonRA[i] = iMAOnArray(RegArr,0,period,0,MODE_EMA,i); 
      // should the total parameter be limit+1 instead of 0 ?

   // printing 4 last current values 
   for(i=3; i>=0; i--)
      Print("MAonRA[",i,"] = ",DoubleToStr(MAonRA[i],Digits+1)); 
   // printing 4 first bars values  
   for(i=Bars-1; i>=Bars-4; i--)
      Print("MAonRA[",i,"] = ",DoubleToStr(MAonRA[i],Digits+1));  
   

   return(0);
  }

